var int zoom_level = 0;
var bool prone_mode_active = 0;
var bool PPN_was_set = 0;
var string PPN;


func pronemode
{
	dmsg "[b.play as konoko - KICK]"
	dmsg "[g.play as striker - PUNCH]"
	fork wait_for_kick
	fork wait_for_punch
}

func wait_for_kick
{
	chr_wait_animtype 0 Kick
	fork wfk_cont

}

### prevents a memory bug
func wfk_cont
{
	if (PPN_was_set eq 0)
	{
		chr_set_class 0 k4_L
		PPN = konoko
		fork check_PPN
	}
}

func wait_for_punch
{
	chr_wait_animtype 0 Punch
	fork wfp_cont
}

func wfp_cont
{
	if (PPN_was_set eq 0)
	{
		chr_set_class 0 striker_easy_1_player_normal
		PPN = striker
		fork check_PPN
	}
}

### PPM = PronePlayerName
func check_PPN
{
	PPN_was_set = 1
	fork prone_now
	fork rif_zoom_on
	fork rif_zoom_off
	fork wait_for_holster
	fork wait_for_draw_rifle
	dmsg "prone mode enabled"
}

func wait_for_holster
{
	chr_wait_animtype 0 Holster
	if ((zoom_level > 0) and (prone_mode_active eq 1))
	{
		cm_distance = 25
		cm_height = 5
		gs_fov_set 50
		cm_canter_weapon = 8
	}
	sleep 60
	fork wait_for_holster
}

func wait_for_draw_rifle
{
	chr_wait_animtype 0 Draw_Rifle
	if (prone_mode_active eq 1)
	{
		fork rifle_content
	}
	sleep 60
	fork wait_for_draw_rifle
}

func wait_for_no_rif_idle
{
	chr_wait_animation 0 STRIKEidle1P STRCOMidle1P STRPISprone_idle1P
	cm_distance = 25
	cm_height = 5
	gs_fov_set 50
	cm_canter_weapon = 8
}

func rifle_content
{
	if (zoom_level eq 1)
	{
		cm_distance = 20
		cm_height = 7
		gs_fov_set 25
		wp_scale_adjustment = 2
		cm_canter_weapon = 2
	}
	if (zoom_level eq 2)
	{
		cm_canter_weapon = 1
		wp_scale_adjustment = 4
		gs_fov_set 10
	}
	if (zoom_level eq 3)
	{
		cm_canter_weapon = 0
		wp_scale_adjustment = 6
		gs_fov_set 3
	}
}

func wait_for_rif_idle
{
	chr_wait_animation 0 STRRIFprone_idleP
	fork rifle_content
}


func rif_zoom_on
{
	chr_wait_animation 0 STRRIFcomb_pP
	if (zoom_level eq 0)
	{
		dmsg "zoom level 1"
		cm_distance = 20
		cm_height = 7
		gs_fov_set 25
		wp_scale_adjustment = 2
		cm_canter_weapon = 2
	}
	if (zoom_level eq 1)
	{
		dmsg "zoom level 2"
		cm_canter_weapon = 1
		wp_scale_adjustment = 4
		gs_fov_set 10
	}
	if (zoom_level eq 2)
	{
		dmsg "zoom level 3"
		cm_canter_weapon = 0
		wp_scale_adjustment = 6
		gs_fov_set 3
	}
	if (zoom_level ne 3)
	{
		zoom_level = zoom_level + 1
	}
	sleep 20
	fork rif_zoom_on
}

func rif_zoom_off
{
	chr_wait_animation 0 STRRIFcomb_kP
	if (zoom_level eq 3)
	{
		dmsg "zoom level 2"
		cm_canter_weapon = 1
		wp_scale_adjustment = 4
		gs_fov_set 10
	}
	if (zoom_level eq 2)
	{
		dmsg "zoom level 1"
		cm_distance = 20
		cm_height = 7
		gs_fov_set 25
		wp_scale_adjustment = 2
		cm_canter_weapon = 2
	}
	if (zoom_level eq 1)
	{
		dmsg "zoom off"
		cm_distance = 25
		cm_height = 5
		gs_fov_set 50
		wp_scale_adjustment = 1
		cm_canter_weapon = 8
	}
	if (zoom_level ne 0)
	{
		zoom_level = zoom_level - 1
	}
	sleep 20
	fork rif_zoom_off

}

func prone_now
{
	if (PPN eq konoko)
	{
		chr_wait_animstate 0 Walking_Sidestep_Right
		prone_mode_active = 1
		sleep 10
		chr_set_class 0 k4_LP
		gs_fov_set 50
		wp_scale_adjustment=1
		cm_distance = 25
		cm_height = 5
		sleep 120
	}
	if (PPN eq striker)
	{
		chr_wait_animstate 0 run_slide
		prone_mode_active = 1
		wp_scale_adjustment = 1
		cm_distance = 25
		cm_height = 5
		sleep 70
		chr_set_class 0 striker_easy_1_player_prone
	}
	fork STRUNIgetup
}

func STRUNIgetup
{
	### wait for this or that animation
	chr_wait_animation 0 STRIKErun_slide_getupP STRCOMrun_slide_getupP STRPISrun_slide_getupP STRRIFrun_slide_getupP
	prone_mode_active = 0
	sleep 40

	if (PPN eq konoko)
	{
		chr_set_class 0 k4_L
	}
	if (PPN eq striker)
	{
		chr_set_class 0 striker_easy_1_player_normal
	}

	fork wait_for_rif_idle
	fork wait_for_no_rif_idle
	cm_distance = 33
	cm_height = 15
	gs_fov_set 50
	wp_scale_adjustment = 1
	cm_canter_weapon = 8
	sleep 30
	fork prone_now
}